/*
 * OptionsForMain.h
 *
 *  Created on: 27.10.2020
 *      Author: bzckaise
 */

#ifndef MAIN_OPTIONSFORMAIN_H_
#define MAIN_OPTIONSFORMAIN_H_

#include "../Utilities/ParseUtilities/OptionsParser/Options.h"
#include "../CleanSolver/SimpSolver/SimpSolver.h"



void set_usage_help_message();

void set_fpu();

void set_CPU_limit();

void set_Memory_limit();

void set_system_options_from_Main();

static Minisat::Solver *solver;

// Note that '_exit()' rather than 'exit()' has to be used. The reason is that 'exit()' calls
// destructors and may cause deadlocks if a malloc/free function happens to be running (these
// functions are guarded by locks for multithreaded use).
static void SIGINT_exit(int signum);

void set_up_signal_handlers(Minisat::SimpSolver &S);

void open_file_for_Drat_proof_generation(Minisat::SimpSolver &S);

void set_Solver_options_from_Main(Minisat::SimpSolver &S);

void handle_special_option_writing_dimacs_after_simplification(
		Minisat::SimpSolver &S);

#endif /* MAIN_OPTIONSFORMAIN_H_ */
