/*
 * RefactorHelperDratPrinter.h
 *
 *  Created on: Nov 14, 2020
 *      Author: kokoro
 */

#ifndef UTILITIES_PRINTUTILITIES_DRATPRINTER_REFACTORHELPERDRATPRINTER_H_
#define UTILITIES_PRINTUTILITIES_DRATPRINTER_REFACTORHELPERDRATPRINTER_H_


#include "../../../CleanSolver/CoreSolver/Solver.h"

inline void close_drat_proof(const Minisat::Solver& S) {
	if (S.drat_printer.drup_file && S.drat_printer.drup_file != stdout)
		fclose(S.drat_printer.drup_file);
}

inline void print_drat_proof_if_unsat(Minisat::Solver& S) {
	if (S.drat_printer.drup_file) {
#ifdef BIN_DRUP
		fputc('a', S.drat_printer.drup_file);
		fputc(0, S.drat_printer.drup_file);
#else
		fprintf(S.drat_printer.drup_file, "0\n");
	#endif
	}
	close_drat_proof(S);
}


#endif /* UTILITIES_PRINTUTILITIES_DRATPRINTER_REFACTORHELPERDRATPRINTER_H_ */
