/*
 * LogfilePrinter.h
 *
 *  Created on: 26.10.2020
 *      Author: bzckaise
 */

#ifndef UTILITIES_PRINTUTILITIES_LOGFILEPRINTER_LOGFILEPRINTER_H_
#define UTILITIES_PRINTUTILITIES_LOGFILEPRINTER_LOGFILEPRINTER_H_

#include <cinttypes>
#include <cstdio>

#include "../../../CleanSolver/CoreSolver/Solver.h"
#include "../../System/System.h"

static double initial_time;
static double parsed_time;
static double prepro_time;

void printStats(const Minisat::Solver &solver);

void print_initial();
void print_after_parsing_Dimacs(const Minisat::Solver &S);
void print_after_preprocessor(const Minisat::Solver &S);
void print_logfile_unsat_after_simplification(const Minisat::Solver &S);
void print_logfile_if_unsat(const Minisat::Solver &S);
void print_logfile_if_unsolved(const Minisat::Solver &S);
void print_logfile_if_model_is_found(const Minisat::Solver &S);

#endif /* UTILITIES_PRINTUTILITIES_LOGFILEPRINTER_LOGFILEPRINTER_H_ */
