/*
 * ResultPrinter.h
 *
 *  Created on: 27.10.2020
 *      Author: bzckaise
 */

#ifndef UTILITIES_PRINTUTILITIES_RESULTPRINTER_RESULTPRINTER_H_
#define UTILITIES_PRINTUTILITIES_RESULTPRINTER_RESULTPRINTER_H_

#include <stdio.h>
#include "../../../CleanSolver/SimpSolver/SimpSolver.h"
static FILE *result_file;

/*
 * This function assumes the file to write the result to is given by argv[2].
 * This is very unfortunate design an is going to be changed soon.
 */
inline void initialize_result_file(int &argc, char **argv) {
	result_file = (argc >= 3) ? fopen(argv[2], "wb") : NULL;
}

inline void print_result_if_unsat() {
	if (result_file != NULL)
		fprintf(result_file, "UNSAT\n"), fclose(result_file);
}

inline void print_result_if_unsolved() {
	if (result_file != NULL)
		fprintf(result_file, "INDET\n"), fclose(result_file);
}

inline void print_result_if_model_is_found(const Minisat::SimpSolver &S) {
	if (result_file != NULL) {
		fprintf(result_file, "SAT\n");
		for (int i = 0; i < S.variable_database.nVars(); i++) {
			// The following using directive is necessary because l_Undef is a
			// Macro. I don't want to change that, yet. FIXME
			using namespace Minisat;
			if (S.model[i] != l_Undef)
				fprintf(result_file, "%s%s%d", (i == 0) ? "" : " ",
						(S.model[i] == l_True) ? "" : "-", i + 1);
		}
		fprintf(result_file, " 0\n");
		fclose(result_file);
	}
}

#endif /* UTILITIES_PRINTUTILITIES_RESULTPRINTER_RESULTPRINTER_H_ */
