#include "boundedqueue.h"

struct bounded_queue *
init_bounded_queue(int sz)
{
    struct bounded_queue * bq = (struct bounded_queue *) malloc(sizeof (struct bounded_queue));
    bq->size=sz;
    bq->q= calloc(bq->size,sizeof (int));
    bq->ptr=0;
    bq->sum=0;
    bq->items=0;
    return bq; 
}

void 
enqueue_bounded_queue(struct bounded_queue *bq, int item)
{
    if(bq->ptr >= bq->size-1)
        bq->ptr=0;
    bq->sum += item - bq->q[bq-> ptr];        
    bq->q[bq->ptr] = item;
    bq->ptr++;
    if(bq->items < bq->size)
        bq->items++;
}

double
avg_bounded_queue(struct bounded_queue *bq)
{
    return bq->items>0? (double) bq->sum / (double) bq->items:0;
}

void 
release_bounded_queue(struct bounded_queue *bq)
{
    free(bq->q);
}

void 
clear_bounded_queue(struct bounded_queue *bq)
{
    for(int i=0;i<bq->size;i++)
        bq->q[i]=0;
    bq->sum=0;
    bq->items=0;
    bq->ptr=0;
}

int 
full_bounded_queue(struct bounded_queue *bq)
{
    return bq->items >= bq->size-1 ? 1 : 0;
}

int 
empty_bounded_queue(struct bounded_queue *bq)
{
    return bq->items==0? 1: 0;
}